dnl	+----------------------------------------------------------------------+
dnl	| PHP Version 4                                                        |
dnl	+----------------------------------------------------------------------+
dnl	| Copyright (c) 1997-2004 The PHP Group                                |
dnl	+----------------------------------------------------------------------+
dnl	| This source file is subject to version 3 of the PHP license,         |
dnl	| that is bundled with this package in the file LICENSE, and is        |
dnl	| available at through the world-wide-web at                           |
dnl	| http://www.php.net/license/3.txt.                                    |
dnl	| If you did not receive a copy of the PHP license and are unable to   |
dnl	| obtain it through the world-wide-web, please send a note to          |
dnl	| license@php.net so we can mail you a copy immediately.               |
dnl	+----------------------------------------------------------------------+
dnl	| Authors:    David Oury <doury@php.net>                               |
dnl	+----------------------------------------------------------------------+
dnl	
dnl	$Id$ 


dnl	*********************************************************************
dnl	*	Sources declaration
dnl	*********************************************************************

sources=""

dir_libs="libs"
src_libs="		binaryDataBuffer.c	\
				common.c			\
				connect.c			\
				socket.c			\
				transcoder.c		\
				string.c			\
				field.c				\
				msg_wrap.c			\
				xml.c				\
				log.c				"
dir_exits="exits"
src_exits="		hwsimso0.c			\
				hwsjava0.c			"
dir_codes="trans"
src_codes="		cp297.c				"

dnl	*********************************************************************
dnl	*	PHP extension configuration
dnl	*********************************************************************

PHP_ARG_ENABLE(ims_connect, whether to enable IMS Connect support,
[ --enable-ims_connect   Enable IMS Connect support])

if test "$PHP_IMS_CONNECT" = "yes"; then

	AC_DEFINE(HAVE_IMS_CONNECT, 1, [Whether you have IMS Connect])

	AC_MSG_RESULT(Transcoding source files :)
	for i in $src_codes; do
		file="$dir_codes/$i"
		sources="$sources $file"
		AC_MSG_RESULT($file)
	done
	AC_MSG_RESULT(IMS libraries source files :)
	for i in $src_libs; do
		file="$dir_libs/$i"
		sources="$sources $file"
		AC_MSG_RESULT($file)
	done
	AC_MSG_RESULT(Exit Modules source files :)
	for i in $src_exits; do
		file="$dir_exits/$i"
		sources="$sources $file"
		AC_MSG_RESULT($file)
	done

	PHP_NEW_EXTENSION(ims_connect, php_ims_connect.c $sources, $ext_shared)
	
	PHP_ADD_INCLUDE($ext_srcdir/$dir_libs)
	PHP_ADD_INCLUDE($ext_srcdir/$dir_exits)
	PHP_ADD_INCLUDE($ext_srcdir/$dir_codes)

fi

