/*
  +----------------------------------------------------------------------+
  | PHP Version 4                                                        |
  +----------------------------------------------------------------------+
  | Copyright (c) 1997-2004 The PHP Group                                |
  +----------------------------------------------------------------------+
  | This source file is subject to version 3 of the PHP license,         |
  | that is bundled with this package in the file LICENSE, and is        |
  | available at through the world-wide-web at                           |
  | http://www.php.net/license/3.txt.                                    |
  | If you did not receive a copy of the PHP license and are unable to   |
  | obtain it through the world-wide-web, please send a note to          |
  | license@php.net so we can mail you a copy immediately.               |
  +----------------------------------------------------------------------+
  | Authors:    David Oury <doury@php.net>                               |
  +----------------------------------------------------------------------+

  $Id: hwsimso0.h,v 1.1 2007/03/27 14:32:36 doury Exp $ 
*/


#ifndef	_IMS_HWSIMSO0_H_
#define	_IMS_HWSIMSO0_H_

/*********************************************************************
 * Constants definitions
 */

/* Headers fields values	*/

#define HWSIMSO0_IRM_ID			"*IRMREQ*"	/* Exit ID : HWSIMSO0	*/

/* Headers data length		*/

#define HWSIMSO0_HDR_IRM_LEN	0x50		/* 80 bytes	*/

/*********************************************************************
 * Data structures declarations
 */

/* Header data		*/
 
typedef struct {
	
	char	MFS_mod;						/* IRM_F1				*/
	char	commitMode;						/* IRM_F2				*/
	char	syncLevel;						/* IRM_F3				*/
	char	nad;							/* IRM_F4				*/
	char *	tranCode;						/* IRM_TRNCOD			*/
	char *	datastoreId;					/* IRM_IMSDESTID		*/
	char *	lterm;							/* IRM_LTERM			*/
	char *	racfUserId;						/* IRM_RACF_USERID		*/
	char *	racfGroupName;					/* IRM_RACF_GRNME		*/
	char *	racfPassword;					/* IRM_RACF_PW			*/
/*	char *	racfAppName;					/* IRM_APPL_NM			*/

} HWSIMSO0_header_t;

/* Exit module configuration	*/
 
typedef struct {

	HWSIMSO0_header_t	headerIRM;			/* Module IRM prefix	*/

} HWSIMSO0_module_t;

/*********************************************************************
 * Functions prototypes declarations
 */

int		HWSIMSO0_setModule(IMS_factory_t *factory);
int		HWSIMSO0_getMsgLength(IMS_message_t *message);
int		HWSIMSO0_buildMessage(IMS_message_t *message, IMS_connect_t *params);
int		HWSIMSO0_writeMessage(IMS_message_t *message, binaryDataBuffer_t *dataBuffer);
int		HWSIMSO0_writeHeaders(binaryDataBuffer_t *dataBuffer, IMS_message_t *message);
int		HWSIMSO0_writeUsrPrefix(binaryDataBuffer_t *dataBuffer, IMS_message_t *message);
int		HWSIMSO0_readMessage(IMS_message_t *message, binaryDataBuffer_t *dataBuffer);

#endif
