/*
  +----------------------------------------------------------------------+
  | PHP Version 4                                                        |
  +----------------------------------------------------------------------+
  | Copyright (c) 1997-2004 The PHP Group                                |
  +----------------------------------------------------------------------+
  | This source file is subject to version 3 of the PHP license,         |
  | that is bundled with this package in the file LICENSE, and is        |
  | available at through the world-wide-web at                           |
  | http://www.php.net/license/3.txt.                                    |
  | If you did not receive a copy of the PHP license and are unable to   |
  | obtain it through the world-wide-web, please send a note to          |
  | license@php.net so we can mail you a copy immediately.               |
  +----------------------------------------------------------------------+
  | Authors:    David Oury <doury@php.net>                               |
  +----------------------------------------------------------------------+

  $Id: binaryDataBuffer.h,v 1.1 2007/03/27 14:32:37 doury Exp $ 
*/


#ifndef	_IMS_BINARY_DATABUFFER_H_
#define	_IMS_BINARY_DATABUFFER_H_

/*********************************************************************
 * Data structures declarations
 */

typedef struct {
	
	unsigned char *	dataBuffer;
	int				dataLength;
	int				dataOffset;

} binaryDataBuffer_t;

/*********************************************************************
 * Function prototypes declarations
 */

binaryDataBuffer_t *	binaryDataBuffer_new();

char *	binaryDataBuffer_initBuffer(binaryDataBuffer_t *dataBuffer, int length);
void	binaryDataBuffer_freeBuffer(binaryDataBuffer_t *dataBuffer);
int		binaryDataBuffer_setOffset(binaryDataBuffer_t *dataBuffer, int offset);
char *	binaryDataBuffer_setBuffer(binaryDataBuffer_t *dataBuffer, char *src, int srcLen);
char *	binaryDataBuffer_addBuffer(binaryDataBuffer_t *dataBuffer, char *src, int srcLen);
char *	binaryDataBuffer_getBuffer(binaryDataBuffer_t *dataBuffer);

int		binaryDataBuffer_writeByte(binaryDataBuffer_t *dataBuffer, int data);
int		binaryDataBuffer_writeShort(binaryDataBuffer_t *dataBuffer, int data);
int		binaryDataBuffer_writeInt(binaryDataBuffer_t *dataBuffer, int data);
int		binaryDataBuffer_writeBytes(binaryDataBuffer_t *dataBuffer, char *data, int data_len);
int		binaryDataBuffer_encodeBytes(binaryDataBuffer_t *dataBuffer, char *data, int data_len, char *decoder);

int		binaryDataBuffer_readByte(binaryDataBuffer_t *dataBuffer, char *data);
int		binaryDataBuffer_readShort(binaryDataBuffer_t *dataBuffer, short *data);
int		binaryDataBuffer_readInt(binaryDataBuffer_t *dataBuffer, int *data);
int		binaryDataBuffer_readBytes(binaryDataBuffer_t *dataBuffer, char *data, int data_len);
int		binaryDataBuffer_decodeBytes(binaryDataBuffer_t *dataBuffer, char *data, int data_len, char *decoder);

#endif
