/*
  +----------------------------------------------------------------------+
  | PHP Version 4                                                        |
  +----------------------------------------------------------------------+
  | Copyright (c) 1997-2004 The PHP Group                                |
  +----------------------------------------------------------------------+
  | This source file is subject to version 3 of the PHP license,         |
  | that is bundled with this package in the file LICENSE, and is        |
  | available at through the world-wide-web at                           |
  | http://www.php.net/license/3.txt.                                    |
  | If you did not receive a copy of the PHP license and are unable to   |
  | obtain it through the world-wide-web, please send a note to          |
  | license@php.net so we can mail you a copy immediately.               |
  +----------------------------------------------------------------------+
  | Authors:    David Oury <doury@php.net>                               |
  +----------------------------------------------------------------------+

  $Id: common.h,v 1.1 2007/03/27 14:32:37 doury Exp $ 
*/


#ifndef	_IMS_COMMON_H_
#define	_IMS_COMMON_H_

/*********************************************************************
 * Constants definitions
 */

/* Boolean values				*/

#define	IMS_TRUE					1		/* Boolean : TRUE	*/
#define	IMS_FALSE					0		/* Boolzan : FALSE	*/

/* Return codes and error codes	*/

#define IMS_CODE_OK					0		/* Return code OK				*/
#define IMS_CODE_ERR				-1		/* eturn code KO				*/

#define IMS_CODE_ERR_ANY			-10		/* EStandard error				*/
#define IMS_CODE_ERR_MALLOC			-20		/* Memory allocation failure	*/
#define IMS_CODE_ERR_ENCODING		-30		/* Unknown encoding				*/
#define IMS_CODE_ERR_TRANSCODE		-40		/* Transcoding failure			*/
#define IMS_CODE_ERR_EXIT			-50		/* Unknown Exit module			*/
#define IMS_CODE_ERR_WRITING		-60		/* Data writing failure			*/
#define IMS_CODE_ERR_READING		-70		/* Data reading failure			*/
#define IMS_CODE_ERR_FIELD			-80		/* Field value error			*/
#define IMS_CODE_ERR_ATTRIBUTE		-90		/* Field attribute error		*/
#define IMS_CODE_ERR_XML_FILE		-100	/* XML format file access error	*/
#define IMS_CODE_ERR_XML_INIT		-110	/* XML initialization error		*/
#define IMS_CODE_ERR_XML_PARSE		-120	/* ErXML parsing error			*/
#define IMS_CODE_ERR_SEND			-130	/* Data sending failure			*/
#define IMS_CODE_ERR_RECEIVE		-140	/* Data receiving failure		*/

#define IMS_LABEL_ERR_PREFIX		"Error {IMS Connector} : "
#define IMS_LABEL_ERR_ANY			"Undefined error"
#define IMS_LABEL_ERR_MALLOC		"Memory allocation failure"
#define IMS_LABEL_ERR_ENCODING		"Unknown encoding"
#define IMS_LABEL_ERR_TRANSCODE		"Transcoding failure"
#define IMS_LABEL_ERR_EXIT			"Unknown IMS Exit module"
#define IMS_LABEL_ERR_WRITING		"IMS message data writing failure"
#define IMS_LABEL_ERR_READING		"IMS message data reading failure"
#define IMS_LABEL_ERR_FIELD			"IMS field value failure"
#define IMS_LABEL_ERR_ATTRIBUTE		"IMS field attribute failure"
#define IMS_LABEL_ERR_XML_FILE		"XML format file access failure"
#define IMS_LABEL_ERR_XML_INIT		"XML parsing initialization failure"
#define IMS_LABEL_ERR_XML_PARSE		"XML parsing execution failure"
#define IMS_LABEL_ERR_SEND			"IMS message data sending to socket failure"
#define IMS_LABEL_ERR_RECEIVE		"IMS message data receiving from socket failure"

/*********************************************************************
 * Macros definitions
 */

#define	MALLOC(_var, _type)				_var = (_type *)(malloc(sizeof(_type)))
#define	EMALLOC(_var, _type)			_var = (_type *)(emalloc(sizeof(_type)))

#define	MALLOC_IS_NULL(_var, _type)		(MALLOC(_var, _type)) == NULL
#define	EMALLOC_IS_NULL(_var, _type)	(EMALLOC(_var, _type)) == NULL

#define	STR_IS_EQUAL(_str1, _str2)		strcmp(_str1, _str2) ? IMS_FALSE : IMS_TRUE

/*********************************************************************
 * Function prototypes declarations
 */

/* Strings treatment		*/

int		_strPad		(char *dest, int destLen, char *src, int srcLen, char filler);
char *	_strBuild	(char *src, int srcLen, int destLen, char filler);
int		_strIsEqual	(char *str1, char *str2);

/* Errors managing			*/

char *	IMS_getErrorLabel(int errorCode);

/* Not used funtions		*/

int		_strEncode	(char *dest, int destLen, char *src, int srcLen, char filler, char *encoder);

#endif
