/*
  +----------------------------------------------------------------------+
  | PHP Version 4                                                        |
  +----------------------------------------------------------------------+
  | Copyright (c) 1997-2004 The PHP Group                                |
  +----------------------------------------------------------------------+
  | This source file is subject to version 3 of the PHP license,         |
  | that is bundled with this package in the file LICENSE, and is        |
  | available at through the world-wide-web at                           |
  | http://www.php.net/license/3.txt.                                    |
  | If you did not receive a copy of the PHP license and are unable to   |
  | obtain it through the world-wide-web, please send a note to          |
  | license@php.net so we can mail you a copy immediately.               |
  +----------------------------------------------------------------------+
  | Authors:    David Oury <doury@php.net>                               |
  +----------------------------------------------------------------------+

  $Id: log.c,v 1.1 2007/03/27 14:32:37 doury Exp $ 
*/


/* Standard libraries		*/
#include <stdlib.h>
#include <stdarg.h>
#include <stdio.h>
#include <time.h>
/* IMS extension libraries	*/
#include "libs/log.h"				/* Log & Debug				*/


/**
 * Debug
 */
int debug(const char *format)
{
	char *		name;
	FILE *		file;
	time_t		t;
	struct tm *	d;
	
	name = LOG_FILENAME;
	file = fopen(name, "a");
	t	 = time(NULL);
	d	 = localtime(&t);
	
	if (file != NULL)
	{
		fprintf(file, LOG_DATE, d->tm_year + 1900, d->tm_mon + 1, d->tm_mday, \
								d->tm_hour, d->tm_min, d->tm_sec);
		fprintf(file, format);
		fprintf(file, "\n");
		fclose(file);
	}
}
