/*
  +----------------------------------------------------------------------+
  | PHP Version 4                                                        |
  +----------------------------------------------------------------------+
  | Copyright (c) 1997-2004 The PHP Group                                |
  +----------------------------------------------------------------------+
  | This source file is subject to version 3 of the PHP license,         |
  | that is bundled with this package in the file LICENSE, and is        |
  | available at through the world-wide-web at                           |
  | http://www.php.net/license/3.txt.                                    |
  | If you did not receive a copy of the PHP license and are unable to   |
  | obtain it through the world-wide-web, please send a note to          |
  | license@php.net so we can mail you a copy immediately.               |
  +----------------------------------------------------------------------+
  | Authors:    David Oury <doury@php.net>                               |
  +----------------------------------------------------------------------+

  $Id: msg_wrap.h,v 1.1 2007/03/27 14:32:37 doury Exp $ 
*/


/*********************************************************************
 * Includes
 */

#include "field.h"					/* IMS Data fields			*/
#include "xml.h"					/* XML Processing			*/


#ifndef	_IMS_MSG_WRAP_H_
#define	_IMS_MSG_WRAP_H_

/*********************************************************************
 * Constants definitions
 */

#define XML_BUFFER_SIZE		2048

/* Error codes		*/

#define	XML_CODE_OK			0
#define	XML_CODE_ERR_INIT	-10
#define	XML_CODE_ERR_FILE	-20
#define	XML_CODE_ERR_PARSE	-30

/*********************************************************************
 * Data structures declarations
 */

typedef struct {

	int					length;		/* Message length			*/
	char *				encoding;	/* Encoding code			*/
	TRANS_trans_t *		trans;		/* Selected transcoding		*/
	IMS_field_t *		f_list;		/* IMS Data fields list		*/
	IMS_field_t *		f_last;		/* Last data field in list	*/
	int					f_size;		/* Chained fields list size	*/

} MSG_wrapper_t;

/*********************************************************************
 * Functions prototypes & macros declarations
 */

#define	MSG_CAST_WRAPPER(_msg, _xml)	MSG_wrapper_t *	_msg = (MSG_wrapper_t *)(_xml->wrapper)

MSG_wrapper_t *	MSG_newWrapper();
int				MSG_freeWrapper(MSG_wrapper_t *wrapper);
int				MSG_initWrapper(MSG_wrapper_t *wrapper, TRANS_trans_t *trans);
int				MSG_setTranscoder(MSG_wrapper_t *wrapper, const char *encoding);
int				MSG_startElem_Message(IMS_xmlData_t *xml_data);
int				MSG_endElem_Message(IMS_xmlData_t *xml_data);
int				MSG_startElem_Field(IMS_xmlData_t *xml_data);
int				MSG_setFieldAttr(IMS_field_t *field, IMS_xmlAttr_t *attribute, char **field_value);

#endif
