/*
  +----------------------------------------------------------------------+
  | PHP Version 4                                                        |
  +----------------------------------------------------------------------+
  | Copyright (c) 1997-2004 The PHP Group                                |
  +----------------------------------------------------------------------+
  | This source file is subject to version 3 of the PHP license,         |
  | that is bundled with this package in the file LICENSE, and is        |
  | available at through the world-wide-web at                           |
  | http://www.php.net/license/3.txt.                                    |
  | If you did not receive a copy of the PHP license and are unable to   |
  | obtain it through the world-wide-web, please send a note to          |
  | license@php.net so we can mail you a copy immediately.               |
  +----------------------------------------------------------------------+
  | Authors:    David Oury <doury@php.net>                               |
  +----------------------------------------------------------------------+

  $Id: socket.h,v 1.1 2007/03/27 14:32:37 doury Exp $ 
*/


#ifndef _IMS_SOCKET_H
#define _IMS_SOCKET_H 

/*********************************************************************
 * Includes
 */

#include "binaryDataBuffer.h"		/* Binary Data Buffering		*/

/*********************************************************************
 * Data structures declarations
 */

typedef struct {
	const char *		host;
	long				port;
	int					socktype;
	struct timeval *	timeout;
	const char *		persistent_id;
} socket_connection_info;

/*********************************************************************
 * Functions prototypes declarations
 */

php_stream	*	socket_connect(socket_connection_info *connection_info);
int				socket_disconnect(php_stream *stream);
long			socket_send(php_stream *stream, const char *data, int data_len);
long			socket_receive(php_stream *stream, char *data, int data_len);
long			socket_receive_to_buffer(php_stream *stream, binaryDataBuffer_t *dataBuffer);

#endif
