/*
  +----------------------------------------------------------------------+
  | PHP Version 4                                                        |
  +----------------------------------------------------------------------+
  | Copyright (c) 1997-2004 The PHP Group                                |
  +----------------------------------------------------------------------+
  | This source file is subject to version 3 of the PHP license,         |
  | that is bundled with this package in the file LICENSE, and is        |
  | available at through the world-wide-web at                           |
  | http://www.php.net/license/3.txt.                                    |
  | If you did not receive a copy of the PHP license and are unable to   |
  | obtain it through the world-wide-web, please send a note to          |
  | license@php.net so we can mail you a copy immediately.               |
  +----------------------------------------------------------------------+
  | Authors:    David Oury <doury@php.net>                               |
  +----------------------------------------------------------------------+

  $Id: string.h,v 1.1 2007/03/27 14:32:37 doury Exp $ 
*/


/*********************************************************************
 * Includes
 */

#include "transcoder.h"						/* IMS Transcoding			*/


#ifndef	_IMS_STRING_H_
#define	_IMS_STRING_H_

/*********************************************************************
 * Constants definitions
 */

#define IMS_ZERO			0x00			/* Binary zero character	*/
#define IMS_BLANK			0x20			/* ASCII blank character	*/

#define	IMS_ALIGN_LEFT		1				/* Align LEFT code			*/
#define	IMS_ALIGN_RIGHT		2				/* Align RIGHT code			*/
#define	IMS_ALIGN_CENTER	3				/* Align CENTER code		*/
#define	IMS_ALIGN_DEFAULT	IMS_ALIGN_LEFT	/* Align DEFAULT code		*/

/*********************************************************************
 * Data structures declarations
 */

/* IMS String	*/

typedef struct {
	char *			string;					/* String data content		*/
	int				length;					/* String data length		*/
	char			filler;					/* Padding character		*/
	char			align;					/* String alignement		*/
	TRANS_trans_t *	trans;					/* Transcoding to use		*/

} IMS_str_t;

/*********************************************************************
 * Functions prototypes declarations
 */

int IMS_newString(IMS_str_t **str, const char *src, int srcLen, char filler, char align, TRANS_trans_t *trans);
int	IMS_initString(IMS_str_t *str, const char *src, int srcLen, char filler, char align, TRANS_trans_t *trans);
int IMS_setString(IMS_str_t *str, const char *src, int srcLen);
int	IMS_freeString(IMS_str_t *str);
int IMS_writeString(IMS_str_t *str, char **buf, int length);
int	IMS_readString(IMS_str_t *str, char *buf, int length);

#endif
