/*
  +----------------------------------------------------------------------+
  | PHP Version 4                                                        |
  +----------------------------------------------------------------------+
  | Copyright (c) 1997-2004 The PHP Group                                |
  +----------------------------------------------------------------------+
  | This source file is subject to version 3 of the PHP license,         |
  | that is bundled with this package in the file LICENSE, and is        |
  | available at through the world-wide-web at                           |
  | http://www.php.net/license/3.txt.                                    |
  | If you did not receive a copy of the PHP license and are unable to   |
  | obtain it through the world-wide-web, please send a note to          |
  | license@php.net so we can mail you a copy immediately.               |
  +----------------------------------------------------------------------+
  | Authors:    David Oury <doury@php.net>                               |
  +----------------------------------------------------------------------+

  $Id: php_ims_connect.h,v 1.1 2007/03/27 14:32:37 doury Exp $ 
*/


#ifndef PHP_IMS_CONNECT_H
#define PHP_IMS_CONNECT_H 1

#ifdef ZTS
#include "TSRM.h"
#endif

ZEND_BEGIN_MODULE_GLOBALS(ims_connect)
	zval *	IMS_execLog;
ZEND_END_MODULE_GLOBALS(ims_connect)

#ifdef ZTS
#define	IMS_CONNECT_G(v)	TSRMG(ims_connect_globals_id, zend_ims_connect_globals *, v)
#else
#define	IMS_CONNECT_G(v)	(ims_connect_globals.v)
#endif

#define PHP_IMS_CONNECT_VERSION "0.1.1"
#define PHP_IMS_CONNECT_EXTNAME "ims"

PHP_MINIT_FUNCTION(ims_connect);
PHP_MSHUTDOWN_FUNCTION(ims_connect);
PHP_RINIT_FUNCTION(ims_connect);
PHP_RSHUTDOWN_FUNCTION(ims_connect);
PHP_MINFO_FUNCTION(ims_connect);

PHP_FUNCTION(ims_connect);
PHP_FUNCTION(ims_wrap_message);
PHP_FUNCTION(ims_unwrap_message);
PHP_FUNCTION(ims_execute);
PHP_FUNCTION(ims_encode);
PHP_FUNCTION(ims_decode);
PHP_FUNCTION(ims_exec_log);
PHP_FUNCTION(ims_print_hexa);

extern zend_module_entry ims_connect_module_entry;
#define phpext_ims_connect_ptr &ims_connect_module_entry

char *	transcode(char *srcStr, int length, int encoding, char transWay);
int		insertExecLog(const char *type, const char *data, int length);
void	echoTrame(char *data, int length, int width);

#endif
